program GenNoLab;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  Dir: Array[1..4, 1..2] of ShortInt = ((1,0), (-1,0), (0,1), (0,-1));

var
  Lab: Array[0..3001, 0..3001] of Char;
  H,N,T: LongInt;
  Used: Array[0..3001] of Boolean;
  a,l,x,y,r,i,j: LongInt;
  min, max: LongInt;
  Height: LongInt;
  Code: Integer;
  FileName: String;

Procedure WriteLab;
var
  F1: Text;
  F: File;
  tN,i,j: LongInt;
  Buf: Array[1..3002] of Char;

begin
  AssignFile(F1, FileName);
  ReWrite(F1);
  WriteLn(F1, N);
  CloseFile(F1);
  AssignFile(F, FileName);
  ReSet(F,1);
  Seek(F,FileSize(F));
  For i:= 1 to N do begin
    For j:= 1 to N do
      Buf[j]:= Lab[i,j];
    Buf[N+1]:= #13; Buf[N+2]:= #10;
    BlockWrite(F, Buf, N+2);
  end;
  CloseFile(F);
end;

Function Num(C: Char): LongInt;
begin
  Num:= Ord('1')-Ord(C);
end;

Procedure Find(x,y: Integer);
var
  t,i: Integer;
  Used: Array[1..4] of Boolean;

begin
  If h > 200000 then exit;
  Lab[x,y]:= '0';
  FillChar(Used, SizeOf(Used), False);
  For i:= 1 to 4 do begin
    t:= Random(4)+1;
    While Used[t] do
      t:= Random(4)+1;
    Used[t]:= True;
    If (1 <= x+Dir[t,1]) and (x+Dir[t,1] <= n) and
       (1 <= y+Dir[t,2]) and (y+Dir[t,2] <= n) then
         If (Lab[x+Dir[t,1], y+Dir[t,2]] = '1') and
            (Num(Lab[x+Dir[t,1], y+Dir[t,2]+1])+
             Num(Lab[x+Dir[t,1], y+Dir[t,2]-1])+
             Num(Lab[x+Dir[t,1]+1, y+Dir[t,2]])+
             Num(Lab[x+Dir[t,1]-1, y+Dir[t,2]]) = 1) then begin
               Inc(h);
               Find(x+Dir[t,1], y+Dir[t,2]);
               Dec(h);
             end;
  end;
end;

begin
  { TODO -oUser -cConsole Main : Insert code here }
  FillChar(Used, SizeOf(Used), False);
 { Write('Enter Size: '); ReadLn(N);
  Write('Enter File: '); ReadLn(FileName);
  Write('Enter RandSeed: '); ReadLn(T); RandSeed:= T;}
  Val(ParamStr(1), N, Code);
  FileName:= ParamStr(2);
  Val(ParamStr(3), RandSeed, Code);
  FillChar(Lab, SizeOf(Lab), '1');
  h:= 0;
  Find(Random(n)+1, Random(n)+1);
  x:= Random(n)+1; y:= Random(n)+1;
  While (Num(Lab[x,y+1])+Num(Lab[x,y-1])+Num(Lab[x-1,y])+Num(Lab[x+1,y]) <= 1) or
        (Lab[x,y] = '0') do begin
          x:= Random(n)+1;
          y:= Random(n)+1;
        end;
  Lab[x,y]:= '0';
  WriteLab;
end.
